<?php

namespace Tests\Unit;

use App\Models\User;
use Illuminate\Foundation\Testing\RefreshDatabase;
use Tests\TestCase;

class BuilderMacrosTest extends TestCase
{
    use RefreshDatabase;
    /**
     * A basic unit test example.
     */
    public function test_where_like_macro(): void
    {
        for ($i = 1; $i < 5; $i++) {
            User::factory()->create(['email' => 'tester@test.com' . $i]);
        }

        $doUsersExist = User::whereLike('email', 'test%')->exists();

        $this->assertTrue($doUsersExist);
    }

    public function test_where_ilike_macro(): void
    {
        for ($i = 1; $i < 5; $i++) {
            User::factory()->create(['name' => 'TEsT' . $i]);
        }

        $doUsersExist = User::whereILike('name', '%es%')->exists();

        $this->assertTrue($doUsersExist);
    }
}
